#!/usr/bin/perl

#############################################################################
# one-login for omail-webmail                                               #
# Copyright (C) 2001 Olivier Mller <om@omnis.ch>                           #
#                                                                           #
# $Id: index.pl,v 1.4 2001/04/20 17:02:53 swix Exp $                       #
# $Source: /cvsroot/omail/webmail/contrib/onelogin/index.pl,v $                              #
#                                                                           #
# This program is free software; you can redistribute it and/or             #
# modify it under the terms of the GNU General Public License               #
# as published by the Free Software Foundation; either version 2            #
# of the License, or (at your option) any later version.                    #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software Foundation,   #
# Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           #
#############################################################################

use strict;
use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);
use MIME::Base64;
use Digest::MD5  qw(md5_base64 md5_hex);

CGI::nph();   # Treat script as a non-parsed-header script
$ENV{PATH} = ""; # no PATH should be needed

################# USER-CONFIGURABLE SECTION ##################

# paths

my $hosts = "webmail-hosts/";
my $login_screen = "login.html";
my $error_screen = "error.html";
my $default_cgi = "omail.pl";
my $logfile = "onelog.txt";

# identification

my $id = "test";

# validity timeout  (seconds)

my $timeout = 100;

############### END USER-CONFIGURABLE SECTION ################

my $now = time + $timeout;
my $login = param("f1");
   $login =~ s/\s//g;            # remove blanks
my $passwd = param("f2");
my $domain = "";
my $username = "";
my $found = 0;
my $host = "";
my $target = "";
my $tmp1 = "";
my $tmp2 = "";
my $tmp3 = "";
my $key = "";
my $cgi = $default_cgi;

if (!$login || !$passwd) {

  print "Location: $login_screen\n\n";
  exit(0);

} else {

  # lookup domain

  if (!($login =~ /(.*)\@(.*)/)) {
    print "Location: $error_screen?wrong_format\n\n";
    exit(0);
  } else {
    $username = $1;
    $domain = $2;
  }

  opendir(DIR, $hosts) || print "Location: $error_screen?open_dir\n\n";
  while (defined($tmp1 = readdir(DIR))) {
    next if $tmp1 =~ /^\.\.?$/;   # ignore "." and ".."
    last if $found;
    open(FILE, "$hosts/$tmp1") || print "Location: $error_screen?open_err2\n\n";
    while($tmp2 = <FILE>) {
	 chomp $tmp2;
	 last if $found;
	 if ($tmp2 eq $domain) {
	   $host = $tmp1;
	   $found = 1;
	   last;
	 }
    }
    close(FILE);
  }
  close(DIR);

  if (!$found) {
    print "Location: $error_screen?not_found\n\n";
  }

  # get secret_key

  open(FILE2, "$hosts/$host.key") || print "Location: $error_screen?open_key&$hosts/$host.key\n\n";
  $key = <FILE2>;
  chomp $key;
  close(FILE2);
  

  # get cgi if any

  if (open(FILE3, "$hosts/$host.cgi")) {
    $cgi = <FILE3>;
    chomp $cgi;
    close(FILE3);
  }

  # urlencode variables

  $passwd =~ s/([\x00-\x20"#%;<>?{}|\\\\^~`\[\]\x7F-\xFF])/
                 sprintf ('%%%x', ord ($1))/eg;
  $passwd =~ s/\s/+/g;

  $login =~ s/([\x00-\x20"#%;<>?{}|\\\\^~`\[\]\x7F-\xFF])/
                 sprintf ('%%%x', ord ($1))/eg;
  $login =~ s/\s/+/g;
                 

  # prepare string:

  $tmp1 = "userid=$login&time=$now&password=$passwd";
  $tmp2 = md5_hex($tmp1 . $key);
  $tmp1 .= "&md5=$tmp2&tmpdata=abcdefgh";
  $tmp3 = encode_base64($tmp1);
  $target = "http://$host/$cgi?action=onelogin&data=$tmp3";
  $target =~ s/\n//g;

  # redirect browser

  print "Location: $target\n\n";

 
  # log 
 
  open(TEST, ">>$logfile");
  print TEST localtime() . "\t$login\t$host\t" .  $ENV{'REMOTE_ADDR'} . "\t" . $ENV{'REMOTE_HOST'} . "\t\n";
  close(TEST);   


}
